/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector<unsigned short> nums;
vector<vector<unsigned short> > seqs(257);
bool paired[257];
unsigned short maxmove;
unsigned short index = 0;

bool findnonpaired(unsigned short& first, unsigned short& second)
{
    unsigned short counter = 0;
    for (size_t i = 0; i <= index; ++i)
    {
        if (!paired[i])
        {
            if (counter == 0)
                first = i;
            else if (counter == 1)
                second = i;
            else
                return false;

            ++counter;
        }
    }
    return (bool)counter;
}

int main()
{
    ifstream cin("game.in");
    ofstream cout("game.out");
    cin >> maxmove;
    while (cin)
    {
        unsigned short num;
        cin >> num;
        if (cin)
        {
            nums.push_back(num);
        }
    }
    //cout << "\tREAD\n";

    // PARTITION BY SEQUENCES
    seqs[0].push_back(nums[0]);
    for (size_t i = 1; i < nums.size(); ++i)
    {
        if (nums[i] == nums[i - 1] + 1)
            seqs[index].push_back(nums[i]);
        else
            seqs[++index].push_back(nums[i]);
    }
    //cout << "\tPARTED\n";

    // MAKE PAIRS
    for (size_t i = 0; i <= index; ++i)
    {
        for (long j = index; j > i; --j)
        {
            if (seqs[i].size() == seqs[j].size())
            {
                paired[i] = true;
                paired[j] = true;
            }
        }
    }
    //cout << "\tPAIRED\n";

    //for (size_t i = 0; i <= index; ++i)
    //    cout << paired[i] << endl;

    // PROCESS
    unsigned short first = 0, second = 0;
    if (!findnonpaired(first, second))
    {
        return 0;
    }
    for (unsigned short move = 1; move <= maxmove; ++move)
    {
        if (second == 0 && seqs[second].size() >= move)
        {
            if ((seqs[first].size() - move) % 2 == 0)
                cout << (seqs[first][0] + seqs[first][seqs[first].size() - 1]) / 2 - move / 2 + (seqs[first].size() % 2 == 0);
        }
        else
        {
            if (seqs[first].size() < seqs[second].size())
                swap(first, second);
            if (seqs[first].size() - seqs[second].size() == move)
            {
                for (size_t i = 0; i <= seqs[first].size() - move; ++i)
                    cout << seqs[first][i] << ' ';
            }
            else if (seqs[second].size() - move == 1)
            {
                for (size_t i = 0; i <= seqs[second].size() - move; ++i)
                    cout << seqs[second][i] << ' ';
            }
        }
        cout << endl;
    }
    //cout << "\tPROCESSED\n";
}
