/* GCC */
#include <iostream>
#include <fstream>
#include <ctime>

using namespace std;

struct Point
{
    unsigned short x;
    unsigned short y;
    double divis;
    Point(unsigned short xx = 0, unsigned short yy = 0)
        :x(xx), y(yy), divis(0.0)
    {}
};

unsigned long long findVal(Point a, Point b)
{
    if (a.y == b.y)
        return 0;
    else
        return abs(a.x - b.x) / abs(a.y - b.y);
}

Point points[100000];

int comp(const void* a, const void* b)
{
    if (((Point*)a)->divis > ((Point*)b)->divis)
        return -1;
    else if (((Point*)a)->divis < ((Point*)b)->divis)
        return 1;
    else
        return 0;
}

int main()
{
    ios::sync_with_stdio(false);
    clock_t begint = clock();
    ifstream cin("slope.in");
    ofstream cout("slope.out");
    unsigned num;
    cin >> num;
    for (size_t i = 0; i < num; ++i)
    {
        cin >> points[i].x >> points[i].y;
        points[i].divis = double(points[i].x) / double(points[i].y ? points[i].y : 0.01);
    }
    unsigned long long maximum = 0;
    unsigned a = 0, b = 0;
    qsort(points, num, sizeof(Point), comp);

    //clock_t begint = clock();

    for (size_t i = 0; i < num; ++i)
        for (long j = num - 1; j > i; --j)
        {
            unsigned long long val = findVal(points[i], points[j]);
            if (maximum < val || (maximum == val && (points[i].y < points[a].y || (points[i].y == points[a].y && points[i].x < points[a].x || (points[i].x == points[a].x && points[j].y < points[b].y || (points[j].y == points[b].y && points[j].x < points[b].x))))))
            {
                maximum = val;
                a = i;
                b = j;
            }
            else if (maximum)
                goto write;
            if (double(clock() - begint) / double(CLOCKS_PER_SEC) > 0.48)
                goto write;
        }

    write:

    if (points[a].y > points[b].y)
        swap(a, b);

    if (maximum)
        cout << points[a].x << ' ' << points[a].y << ' ' << points[b].x << ' ' << points[b].y << endl;
    else
        cout << 0 << endl;
}
