/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <limits>

using namespace std;

struct point {
    point (int ix = 0, int iy = 0) {
        x = ix;
        y = iy;
    }

    int x, y;
};

double tango(const point &a, const point &b)
{
    if (a.x == b.x || a.y == b.y)
        return M_PI_2;
    return atan(abs((double)(a.y-b.y))/abs((double)(a.x-b.x)));
}

int n;
vector<point> z;

int main()
{
    freopen("slope.in", "r", stdin);
    freopen("slope.out", "w", stdout);

    scanf("%d\n", &n);
    for (int k = 0; k < n; k++) {
        point pt;
        scanf("%d %d\n", &pt.x, &pt.y);
        z.push_back(pt);
    }

    double btg = M_PI_2;
    pair<point, point> bpt;
    for (int k = 0; k < n; k++) {
        for (int j = k+1; j < n; j++) {
            double tg = tango(z[k], z[j]);
            if (tg < btg) {
                btg = tg;
                bpt.first = z[k];
                bpt.second = z[j];
            } else if (tg == btg) {
                if (min(bpt.first.y, bpt.second.y) > min(z[k].y, z[j].y)) {
                    bpt.first = z[k];
                    bpt.second = z[j];
                } else if (min(bpt.first.x, bpt.second.x) > min(z[k].x, z[j].x)) {
                    bpt.first = z[k];
                    bpt.second = z[j];
                }
            }
        }
    }

    if (btg == M_PI_2) {
        cout << 0 << endl;
        return 0;
    }

    if (bpt.first.y < bpt.second.y) {
        printf("%d %d %d %d\n", bpt.first.x, bpt.first.y,
                                bpt.second.x, bpt.second.y);
    } else {
        printf("%d %d %d %d\n", bpt.second.x, bpt.second.y,
                                bpt.first.x, bpt.first.y);
    }

    return 0;
}
